﻿' VB.NET to Create a Symbol
'   lines starting with an apostrophe are comments
Public Class CreateSym

    ' create Visual CADD object
    Shared WithEvents vcadd As New VCadd32.Automation

    Public Shared Function Run(ByVal str As String) As Integer

        '   construct two point objects
        Dim pt0 As New VCadd32.VCPoint2D
        Dim pt1 As New VCadd32.VCPoint2D

        '   Create a symbol name:
        '       Create a reference to the symbol definition. The 
        '       definition allows the code to add a symbol to 
        '       currently active drawing session based on an internal 
        '       name.  The following code creates a new definition 
        '       with the name "MySymbolDefintion":

        Dim iSymbolIndex As Integer
        iSymbolIndex = vcadd.CreateSymbolDef("MySymbolDefintion")

        '   Add the entities directly to the symbol definition:
        '       The following code adds entities directly to the new 
        '       symbol definition.

        pt0.X = 0
        pt0.Y = 0
        pt1.X = 0
        pt1.Y = 10

        vcadd.AddCircleEntity(iSymbolIndex, pt0, pt1)
        vcadd.AddLineEntity(iSymbolIndex, pt0, pt1)

        '   Optional: Save the symbol definition to disk:
        '       When a symbol definition is created it is simply 
        '       loaded into the current drawing session.  In order to 
        '       utilize the definition in future drawing sessions, it 
        '       must be saved to disk.  The following code saves the 
        '       symbol to a VCS file.

        vcadd.SaveVCS("MySymbolDefinition", "C:\MyPath\Symbols\MySymbol.vcs")

        ' return
        Return (True)

    End Function

End Class
