﻿' VB.NET to Parse On Screen
'   lines starting with an apostrophe are comments
Public Class ParseOnScrn

    ' create Visual CADD object
    Shared WithEvents vcadd As New VCadd32.Automation

    Public Shared Function Run(ByVal str As String) As Integer

        '   used for messages
        Dim sz As String

        '   Reset the on screen list with the new zoom:
        '       When working with display and zoom related parsing 
        '       methods, the items selection list needs to be reset 
        '       prior to each parsing.  This ensures the current 
        '       zoom, whether changed directly through code or from 
        '       the user interface, is reflected in the on screen 
        '       search.  The following code resets the screen list 
        '       for the current zoom:

        vcadd.ResetOnScreenList()

        '   Parse the list:
        '       The routines to parse the list coincide with standard 
        '       methods of moving from the first item in the list to 
        '       the next until the end of the list is reached.  The 
        '       following code parses the new screen list:

        '   setup a counter
        Dim iCount As Integer = 0

        '   start at the first selected entity
        Dim iKind As Short
        iKind = vcadd.FirstOnScreen()

        Do While (vcadd.GetErrorCode() = 0)
            '   your tool would do whatever processing is required
            '       for example, count the lines on screen
            If (iKind = CONTINUOUSLINE2D) Then
                iCount = iCount + 1
            End If

            iKind = vcadd.NextOnScreen()
        Loop

        sz = "Continuous line count: " + CStr(iCount)
        MsgBox(sz, MsgBoxStyle.Information, "API Help Sample")

        ' return
        Return (True)

    End Function

End Class
