﻿' VB.NET to Retrieve a Symbol Count
'   lines starting with an apostrophe are comments
Public Class RetrieveSym

    ' create Visual CADD object
    Shared WithEvents vcadd As New VCadd32.Automation

    Public Shared Function Run(ByVal str As String) As Integer

        '   used for messages
        Dim sz As String
        Dim szSymName As String

        '   Retrieve the symbol definition count:
        '       Symbol definitions are loaded into the drawing 
        '       session as new drawings are loaded or by specific 
        '       commands to load them.  The following code retrieves 
        '       a count for the number of currently loaded symbol 
        '       definitions:

        Dim iLoadedCount As Short
        iLoadedCount = vcadd.GetSymbolDefCount()

        '   Parse the symbol definitions and retrieve the placement 
        '   count:
        '       After retrieving the number of definitions loaded in 
        '       the session, an application can then simply move 
        '       through the list and get the necessary information.  
        '       The following code parses the symbol definitions and 
        '       retrieves the name and number of placements for each 
        '       definition.

        For iIndex As Short = 0 To iLoadedCount - 1
            szSymName = vcadd.GetSymbolName(iIndex)

            Dim iPlacedCount As Short
            iPlacedCount = vcadd.GetSymbolPlacementCount(iIndex)

            sz = "Symbol Index: " + CStr(iIndex) + vbLf
            sz = sz + "Name: " + szSymName + vbLf
            sz = sz + "Placed: " + CStr(iPlacedCount) + " time(s)"
            MsgBox(sz, MsgBoxStyle.Information, "API Help Sample")
        Next
        
        ' return
        Return (True)

    End Function

End Class
